#pragma once

#include "R6Card.h"
#include "AutoFile.h"





#define WM_READALL_START                            WM_USER+200   //ʼ
#define WM_READALL_STEP                             WM_USER+201   //ɶһ,һҳ
#define WM_READALL_END                              WM_USER+202   //ȫ
#define WM_READALL_ERROR                            WM_USER+203   //ȡ̳



#define WM_WRITEALL_START                           WM_USER+204   //ʼд
#define WM_WRITEALL_STEP                            WM_USER+205   //дһ,дһҳ,һ
#define WM_WRITEALL_END                             WM_USER+206   //ȫд
#define WM_WRITEALL_ERROR                           WM_USER+207   //д̳



#define WM_CHECKSTRUCTURE_START                     WM_USER+208   //ʼѼ
#define WM_CHECKSTRUCTURE_STEP                      WM_USER+209   //ɼһ,ID
#define WM_CHECKSTRUCTURE_END                       WM_USER+210   //Ѽ
#define WM_CHECKSTRUCTURE_ERROR                     WM_USER+211   //̳




#define ERROR_DEVICE                                1             //豸
#define ERROR_STOP                                  2             //ǿֹ
#define ERROR_DOING                                 3             //豸
#define ERROR_FILE                                  4             //ļ
#define ERROR_CARD                                  5             //޲NDS
#define ERROR_ICBUSY                                6             //оƬæ
#define ERROR_ICPROTECT                             7             //оƬ
#define ERROR_ICUNKNOW                              8             //δ֪оƬ



typedef enum _THREAD_RUN_MODE
{
	    NONEDO                      = 0,             //޶,ڲ߳Ҳû
		CHECKSTRUCTURE              = 1,             //IC
		READALL                     = 2,             //ȫ
		WRITEALL                    = 3,             //дȫ
}THREAD_RUN_MODE;








typedef struct _MEMORY_TYPE
{
	MEMORY_ID id;
	MEMORY_ENTRY_MODE mode;
}MEMORY_TYPE;

typedef CArray<MEMORY_TYPE,MEMORY_TYPE>   CMemoryTypeArray;






typedef struct _DS_CARTRIDGE_HEADER
{
	char     gametitle[12];
	char     gamcode[4];
	char     makercode[2];
	BYTE     unitcode;
	BYTE     encryptionseedselect;
	BYTE     devicecapacity;
	BYTE     reserved1[9];
	BYTE     romversion;
	BYTE     autostart;

	UINT     arm9romoffset;
	UINT     arm9entryaddress;
	UINT     arm9ramaddress;
	UINT     arm9size;
	
	UINT     arm7romoffset;
	UINT     arm7entryaddress;
	UINT     arm7ramaddress;
	UINT     arm7size;

	UINT     filenametalbeoffset;
	UINT     filenametablesize;
	UINT     fileallocationtableoffset;
	UINT     fileallocationtablesize;
    UINT     filearm9overlayoffset;
	UINT     filearm9overlaysize;
	UINT     filearm7overlayoffset;
	UINT     filearm7overlaysize;
	
	UINT     normalcommands;
	UINT     key1commands;
	UINT     icontitleoffset;
	USHORT   secureareachecksum;
	USHORT   securearealoading;
    UINT     arm9autoloadlist;
	UINT     arm7autoloadlist;
	BYTE     secureareadisable[8];
	UINT     totalusedromsize;
	UINT     romheadersize;

	BYTE     reserved2[0x38];
	BYTE     nintendologo[0x9c];
	USHORT   nintendologochecksum;

	USHORT   headerchecksum;
	UINT     debugromoffset;
	UINT     debugsize;
	UINT     debugramaddress;

	BYTE     reserved3[4];
	BYTE     reserved4[0x90];
}DS_CARTRIDGE_HEADER;













class CNdsCard
{
public:
	CNdsCard(void);
	~CNdsCard(void);

	CString           GetCardType();
	UINT              GetMemoryTotal();	
	CString           GetMemoryType(UINT index);
	CString           GetMemoryClass(UINT index);
    MEMORY_ENTRY_MODE GetMemoryMode(UINT index);    
    MEMORY_ID         GetMemoryTypeId(UINT index);

	VOID              StartCheckMemory();
    VOID              StartReadMemory(UINT index,CString filepath);
	VOID              StartWriteMemory(UINT index,CString filepath);
	VOID              ThreadSuspend();
	VOID              ThreadResume();	
	VOID              ThreadWait();
	VOID              ThreadStop();
    THREAD_RUN_MODE   GetThreadRunMode();
    CString           GetErrorString(UINT lParam);

	static CString    GetR6CardName();
	static CString    GetOriginalCardName();
    static CString    GetTitle();
	static VOID       BuildDSheaderFile(CString filepath);
	static CString    CharArrayToString(char * pbuff);
	static CString    UintToString(UINT buff);
	static CString    UshortToString(USHORT buff);
	static CString    ByteToString(BYTE buff);
	static CString    ByteArrayToString(PBYTE pbuff,UINT len);


private:
	CString           m_CardType;
	CMemoryTypeArray  m_MemoryTypeList;
	UINT              m_SelectMemoryIndex;
	CString           m_FilePath;

	CWinThread  *     m_Thread;
	BOOL              m_ThreadRun;      //ֹ߳
	THREAD_RUN_MODE   m_ThreadRunMode;  //߳ģʽ




    VOID              MemoryTypeListAdd(MEMORY_ENTRY_MODE mode,MEMORY_ID id);

	static UINT       ReadAllThread(LPVOID param);
	static UINT       WriteAllThread(LPVOID param);
	static UINT       CheckStructureThread(LPVOID param);
};