// TreeCtrlDev.cpp : ʵļ
//

#include "stdafx.h"
#include "NDSbackup.h"
#include "TreeCtrlDev.h"
#include ".\treectrldev.h"


// CTreeCtrlDev

IMPLEMENT_DYNAMIC(CTreeCtrlDev, CTreeCtrl)
CTreeCtrlDev::CTreeCtrlDev()
{
	m_PCItem=NULL;
	m_AdapterItem=NULL;
	m_CardItem=NULL;
}

CTreeCtrlDev::~CTreeCtrlDev()
{
}


BEGIN_MESSAGE_MAP(CTreeCtrlDev, CTreeCtrl)
	ON_WM_DRAWITEM()
END_MESSAGE_MAP()



// CTreeCtrlDev Ϣ




VOID  CTreeCtrlDev::Init(CString pcname)
{ 
    //
	// Lines At Root = True;
	// Has Lines = True;
	// Has Buttons = True;
    // UINT width=GetIndent();
	// SetIndent(width+width/10);

	// UINT height=GetItemHeight();
	// SetItemHeight(height+height/10);


	TVINSERTSTRUCT root;
	root.hParent = NULL;
	root.hInsertAfter = TVI_ROOT;
	root.item.mask = TVIF_TEXT|TVIF_PARAM;
	root.item.pszText = (LPSTR)pcname.GetBuffer();	
	root.item.lParam = 0xFFFFFFFF;
  
	m_PCItem = InsertItem(&root);
	pcname.ReleaseBuffer();
}






VOID CTreeCtrlDev::InsertDevice(CString type)
{
	if(m_PCItem == NULL)
		return;

    type = "Device:   "+type;
	TVINSERTSTRUCT adapter;
	adapter.hParent = m_PCItem;
	adapter.hInsertAfter = TVI_LAST;
	adapter.item.mask = TVIF_TEXT|TVIF_PARAM;
	adapter.item.pszText = (LPSTR)type.GetBuffer();
	adapter.item.lParam = 0xFFFFFFFF;

	m_AdapterItem=InsertItem(&adapter);
	type.ReleaseBuffer();

	Expand(m_PCItem,TVE_EXPAND);
}





VOID CTreeCtrlDev::RemoveDevice()
{	
	HTREEITEM hCurrent = m_AdapterItem;
	while (hCurrent != NULL)
	{
		// Get the text for the item. Notice we use TVIF_TEXT because
		// we want to retrieve only the text, but also specify TVIF_HANDLE
		// because we're getting the item by its handle.
		TVITEM item;
		//TCHAR szText[1024];
		item.hItem = hCurrent;
		item.mask = TVIF_HANDLE;
		//item.mask = TVIF_TEXT | TVIF_HANDLE;
		//item.pszText = szText;
		//item.cchTextMax = 1024;

		BOOL bWorked = GetItem(&item);

		// Try to get the next item
		hCurrent = GetNextItem(hCurrent, TVGN_NEXT);

		// If we successfuly retrieved an item, and the item's text
		// contains a lowercase letter 'e', delete the item.
		//if (bWorked && _tcschr(item.pszText, 'e'))
		DeleteItem(item.hItem);
	}
    //DeleteItem(m_AdapterItem);
	m_AdapterItem=NULL;
}





VOID CTreeCtrlDev::InsertCard(CString type)
{
	if(m_AdapterItem == NULL)
		return;

    type = "NDS Card:  "+type;
	TVINSERTSTRUCT card;
	card.hParent = m_AdapterItem;
	card.hInsertAfter = TVI_LAST;
	card.item.mask = TVIF_TEXT|TVIF_PARAM;
	card.item.pszText = (LPSTR)type.GetBuffer();	
	card.item.lParam = 0xFFFFFFFF;

	m_CardItem=InsertItem(&card);
	type.ReleaseBuffer();

    Expand(m_AdapterItem,TVE_EXPAND);

}



VOID CTreeCtrlDev::RemoveCard()
{	
	HTREEITEM hCurrent = m_CardItem;
	while (hCurrent != NULL)
	{
		// Get the text for the item. Notice we use TVIF_TEXT because
		// we want to retrieve only the text, but also specify TVIF_HANDLE
		// because we're getting the item by its handle.
		TVITEM item;
		//TCHAR szText[1024];
		item.hItem = hCurrent;
		item.mask = TVIF_HANDLE;
		//item.mask = TVIF_TEXT | TVIF_HANDLE;
		//item.pszText = szText;
		//item.cchTextMax = 1024;

		BOOL bWorked = GetItem(&item);

		// Try to get the next item
		hCurrent = GetNextItem(hCurrent, TVGN_NEXT);

		// If we successfuly retrieved an item, and the item's text
		// contains a lowercase letter 'e', delete the item.
		//if (bWorked && _tcschr(item.pszText, 'e'))
		DeleteItem(item.hItem);
	}
	//DeleteItem(m_AdapterItem);
	m_CardItem=NULL;
	m_MemoryArray.RemoveAll();
}






VOID CTreeCtrlDev::InsertMemory(CString classname,CString type,UINT lParam)
{
	if(m_CardItem == NULL)
		return;

	type = classname+":  "+type;
	TVINSERTSTRUCT mem;
	mem.hParent = m_CardItem;
	mem.hInsertAfter = TVI_LAST;
	mem.item.mask = TVIF_TEXT|TVIF_PARAM;
	mem.item.pszText = (LPSTR)type.GetBuffer();	
	mem.item.lParam = lParam;

	m_MemoryArray.Add(InsertItem(&mem));
	type.ReleaseBuffer();

	Expand(m_CardItem,TVE_EXPAND);
	SelectItem(m_MemoryArray.GetAt(0));
}


VOID CTreeCtrlDev::SelectMemory(UINT index)
{
    SelectItem(m_MemoryArray.GetAt(index));
}


VOID CTreeCtrlDev::SelectLastMemory()
{
    UINT tt=(UINT)m_MemoryArray.GetCount();
    SelectItem(m_MemoryArray.GetAt(tt-1));
}




VOID  CTreeCtrlDev::RemoveAllMemories()
{
	UINT tt=(UINT)m_MemoryArray.GetCount();
    for(UINT ab=0;ab<tt;ab++)
	{
		DeleteItem(m_MemoryArray.GetAt(ab));
	}
	m_MemoryArray.RemoveAll();
}








UINT  CTreeCtrlDev::GetSelectedItemlParam()
{
	HTREEITEM curitem=GetSelectedItem();
	TVITEM treeitem;
	treeitem.mask = TVIF_HANDLE|TVIF_PARAM;//ΪhItemڴ,ȻhItem
	treeitem.hItem=curitem;
	GetItem(&treeitem);
	return (UINT)treeitem.lParam;
}


void CTreeCtrlDev::OnDrawItem(int nIDCtl, LPDRAWITEMSTRUCT lpDrawItemStruct)
{
	// TODO: ڴϢ/Ĭֵ

	CTreeCtrl::OnDrawItem(nIDCtl, lpDrawItemStruct);
}
